      SUBROUTINE FRIC(LM,TAU,DDTDDG,DDTDDP,DSLIP,SED,SFD,
     1     DDTDDT,PNEWDT,STATEV,DGAM,TAULM,PRESS,DPRESS,DDPDDH,
     2     SLIP,KSTEP,KINC,TIME,DTIME,NOEL,CINAME,SLNAME,
     3     MSNAME,NPT,NODE,NPATCH,COORDS,RCOORD,DROT,TEMP,
     4     PREDEF,NFDIR,MCRD,NPRED,NSTATV,CHRLNGTH,PROPS,NPROPS)
C                    
      INCLUDE 'ABA_PARAM.INC'
C                    
      CHARACTER*80 CINAME,SLNAME,MSNAME
      DIMENSION TAU(NFDIR),DDTDDG(NFDIR,NFDIR),DDTDDP(NFDIR),
     1     DSLIP(NFDIR),DDTDDT(NFDIR,2),STATEV(*),
     2     DGAM(NFDIR),TAULM(NFDIR),SLIP(NFDIR),
     3     COORDS(MCRD),RCOORD(MCRD),DROT(2,2),TEMP(2),
     4     PREDEF(2,*),TIME(2),PROPS(NPROPS)
C                    
      PARAMETER(ZERO=0.0D0,PRECIS=1.0D-14)
C                    
C                    LAGRANGE IMPLEMENTATION OF
C                    2-D COULOMB FRICTION
C                    XMU IS THE COEFFICIENT OF FRICTION
C                    
      XMU = PROPS(1)
C                    
C                    CHECK IF PRESSURE IS NON-POSITIVE
C                    
      IF (PRESS .LE. ZERO) THEN
C                       
C                       PROVIDE THE DTAU/DP, ETC
C                       
         IF (ABS(DGAM(1)) .EQ. ZERO) THEN
C                          
C                          IF PRESSURE IS NON-POSITIVE
C                          AND NO SLIP, SET CONDITION
C                          TO STICKING
C                          
            LM = 1
         ELSE
            DDTDDG(1,1) = ZERO
            DDTDDP(1)   = SIGN(XMU,DGAM(1))
            TAU(1)      = ZERO
            DSLIP(1)    = DGAM(1)
            LM = 0
         ENDIF
         RETURN
      ENDIF
C                    
C                    COMPUTE FOR CRITICAL SHEAR STRESS
C                    FOR COULOMB FRICTION
C                    
      TAUCRIT = XMU * PRESS
      IF (LM .EQ. 2) THEN
C                       
C                       GAP IS OPEN IN PREVIOUS
C                       INCREMENT
C                       
         IF (XMU .GT. PRECIS) THEN
C
C                          NONZERO FRICTION COEFFICIENT,
C                          SET CONDITION TO STICKING
            LM = 1
         END IF
      ELSE IF (LM .EQ. 1) THEN
C                       
C                       STICKING IN PREVIOUS ITERATION
C                       
C                       COMPARE WITH CRITICAL SHEAR STRESS
C                       
         IF (ABS(TAULM(1)).LE.TAUCRIT) THEN
C                          
C                          CONDITION IS STILL STICKING
C                          
            LM = 1
         ELSE
C                          
C                          CONDITION CHANGED FROM STICK TO SLIP
C                          
            LM = 0
            TAU(1)      = SIGN(TAUCRIT,TAULM(1))
            DDTDDG(1,1) = ZERO
            DDTDDP(1)   = SIGN(XMU,TAULM(1))
            DSLIP(1)    = DGAM(1)
         ENDIF
      ELSE                                                               
C                       
C                       SLIPPING IN PREVIOUS ITERATION
C                       
C                       CHECK FOR SLIP REVERSAL
C                       
         IF (DSLIP(1) .EQ. ZERO) THEN
C                          
C                          THIS CONDITION OCCURS IF IT WAS STICKING
C                          PRIOR TO SLIPPING IN PREVIOUS
C                          ITERATION
C                          
            CHECK = ABS(DGAM(1))
         ELSE
            CHECK = DSLIP(1)*DGAM(1)
         ENDIF
         IF (CHECK .GT. ZERO) THEN
C                          
C                          NO REVERSAL IN SLIP
C                          
            LM = 0
            TAU(1)      = SIGN(TAUCRIT,DGAM(1))
            DDTDDG(1,1) = ZERO
            DDTDDP(1)   = SIGN(XMU,DGAM(1))
            DSLIP(1)    = DGAM(1)
         ELSE
C                          
C                          REVERSAL IN SLIP
C                          
            LM = 1
         ENDIF
      ENDIF               
      RETURN
      END


