      SUBROUTINE FRIC(LM,TAU,DDTDDG,DDTDDP,DSLIP,SED,SFD,
     1     DDTDDT,PNEWDT,STATEV,DGAM,TAULM,PRESS,DPRESS,DDPDDH,
     2     SLIP,KSTEP,KINC,TIME,DTIME,NOEL,CINAME,SLNAME,
     3     MSNAME,NPT,NODE,NPATCH,COORDS,RCOORD,DROT,TEMP,
     4     PREDEF,NFDIR,MCRD,NPRED,NSTATV,CHRLNGTH,PROPS,NPROPS)
C                    
      INCLUDE 'ABA_PARAM.INC'
C                    
      CHARACTER*80 CINAME,SLNAME,MSNAME
      DIMENSION TAU(NFDIR),DDTDDG(NFDIR,NFDIR),DDTDDP(NFDIR),
     1     DSLIP(NFDIR),DDTDDT(NFDIR,2),STATEV(*),
     2     DGAM(NFDIR),TAULM(NFDIR),SLIP(NFDIR),
     3     COORDS(MCRD),RCOORD(MCRD),DROT(2,2),TEMP(2),
     4     PREDEF(2,*),TIME(2),PROPS(NPROPS)
C                    
      DIMENSION AN(2)
C                    
      PARAMETER(ZERO=0.0D0,ASMALL=1.0D-27,PRECIS=1.D-14,XKS=1.D6)
C                    
C                    
C                    LAGRANGE IMPLEMENTATION OF 3-D
C                    COULOMB FRICTION
C                    XMU IS THE COEFFICIENT OF FRICTION
C                    
      XMU = PROPS(1)
C                    
C                    CHECK IF PRESSURE IS NON-POSITIVE
C                    
      IF (PRESS .LE. ZERO) THEN
C                       
C                       PROVIDE THE DTAU/DP, ETC
C                       
         GAMEQV = SQRT(DGAM(1)**2 + DGAM(2)**2)
         IF (GAMEQV .EQ. ZERO) THEN
            LM = 1
         ELSE
            DDTDDG(1,1) = ZERO
            DDTDDG(1,2) = ZERO
            DDTDDG(2,1) = ZERO
            DDTDDG(2,2) = ZERO
            DDTDDP(1)   = XMU * DGAM(1)/GAMEQV
            DDTDDP(2)   = XMU * DGAM(2)/GAMEQV
            TAU(1)      = ZERO
            TAU(2)      = ZERO
            DSLIP(1)    = DGAM(1)
            DSLIP(2)    = DGAM(2)
            LM = 0
         ENDIF
         RETURN
      ENDIF
C                    
C                    COMPUTE FOR CRITICAL SHEAR STRESS
C                    
      TAUCRIT = XMU * PRESS
      IF (LM .EQ. 2) THEN
C                       
C                       GAP IS OPEN IN PREVIOUS
C                       INCREMENT
C                       
         IF (XMU .GT. PRECIS) THEN
C
C                          NONZERO FRICTION COEFFICIENT,
C                          SET CONDITION TO STICKING
            LM = 1
         END IF
      ELSE IF (LM .EQ. 1) THEN
C                       
C                       STICKING IN PREVIOUS ITERATION
C                       
C                       COMPARE WITH CRITICAL SHEAR STRESS
C                       
         TAULEQV = SQRT(TAULM(1)**2 + TAULM(2)**2)
         IF (TAULEQV .LE. TAUCRIT) THEN
C                          
C                          CONDITION IS STILL STICKING
C                          
            LM = 1
         ELSE
C                          
C                          CONDITION CHANGED FROM STICK TO SLIP
C                          
            LM = 0
            AN(1)       = TAULM(1)/TAULEQV
            AN(2)       = TAULM(2)/TAULEQV
            TAU(1)      = TAUCRIT * AN(1)
            TAU(2)      = TAUCRIT * AN(2)
            COEFF       = XKS*TAUCRIT/TAULEQV
            DDTDDG(1,1) = COEFF*AN(2)*AN(2)
            DDTDDG(1,2) = -COEFF*AN(1)*AN(2)
            DDTDDG(2,1) = DDTDDG(1,2)
            DDTDDG(2,2) = COEFF*AN(1)*AN(1)
            DDTDDP(1)   = XMU * AN(1)
            DDTDDP(2)   = XMU * AN(2)
            DSLIP(1)    = TAULM(1)/XKS
            DSLIP(2)    = TAULM(2)/XKS
         ENDIF
      ELSE                                                               
C                       
C                       SLIPPING IN PREVIOUS ITERATION
C                       
         DSLIPEQV = SQRT(DSLIP(1)**2 + DSLIP(2)**2)
         GAMEQV   = SQRT(DGAM(1)**2 + DGAM(2)**2)
         IF (DSLIPEQV .EQ. ZERO .OR. GAMEQV .EQ. ZERO) THEN
C                          
C                          THIS OCCURS IF IT WAS STICKING
C                          PRIOR TO SLIPPING IN PREVIOUS
C                          ITERATION
C                          
            CHECK = GAMEQV
         ELSE
C                          
C                          CHECK FOR REVERSAL
C                          
            DOTP  = DSLIP(1)*DGAM(1) + DSLIP(2)*DGAM(2)
            DOTPN = DOTP/(DSLIPEQV*GAMEQV)
            IF (DOTPN .EQ. ZERO) THEN
               CHECK = ASMALL
            ELSE
               CHECK = DOTPN
            ENDIF
         ENDIF
         IF (CHECK .GT. ZERO) THEN
            LM = 0
            CONST  = TAUCRIT/GAMEQV
            AN(1)       = DGAM(1)/GAMEQV
            AN(2)       = DGAM(2)/GAMEQV
            TAU(1)      = TAUCRIT * AN(1)
            TAU(2)      = TAUCRIT * AN(2)
            DDTDDG(1,1) = AN(2)*AN(2)*CONST
            DDTDDG(1,2) = -AN(1)*AN(2)*CONST
            DDTDDG(2,1) = DDTDDG(1,2)
            DDTDDG(2,2) = AN(1)*AN(1)*CONST
            DDTDDP(1)   = XMU * AN(1)
            DDTDDP(2)   = XMU * AN(2)
            DSLIP(1)    = DGAM(1)
            DSLIP(2)    = DGAM(2)
         ELSE
C                          
C                          REVERSAL IN SLIP
C                          
            LM = 1
         ENDIF
      ENDIF               
      RETURN
      END

